/*
  teem: Gordon Kindlmann's research software
  Copyright (C) 2002, 2001, 2000, 1999, 1998 University of Utah

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <stdio.h>
#include "../air.h"

char *me;

int
endian(void) {
  short word;
  char *byte;

  word = 0x0001;
  byte = (char *)&word;
  return (*byte ? airEndianLittle : airEndianBig);
}

int
main(int argc, char *argv[]) {

  me = argv[0];

  printf("%s: airMyEndian = %d (%s)\n", me, airMyEndian, 
	 airEnumStr(airEndian, airMyEndian));
  if (airMyEndian == endian()) {
    printf("%s: (agrees with run-time test)\n", me);
  }
  else {
    printf("%s: !!!!\n", me);
    printf("%s: !!!! PROBLEM: run-time test says endian is %s,\n", 
	   me, airEnumStr(airEndian, endian()));
    printf("%s: !!!! but compile-time constant says endian is %s.\n", 
	   me, airEnumStr(airEndian, airMyEndian));
    printf("%s: !!!!\n", me);
  }

  exit(0);
}
