/*
  teem: Gordon Kindlmann's research software
  Copyright (C) 2002, 2001, 2000, 1999, 1998 University of Utah

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../air.h"

typedef enum {
  testUnknown,              /* 0 */
  testBingo,                /* 1 */
  testAlpha,                /* 2 */
  testPotato,               /* 3 */
  testNeoClassicalPeriod,   /* 4 */
  testSUV,                  /* 5 */
  testLast
} testEnumInt;
#define TEST_ENUM_MAX          5

char
testEnumStr[][AIR_STRLEN_SMALL] = {
  "(unknown_test)",
  "bingo!",
  "Moi je sais mon ABC",
  "You say potato ...",
  "Picasso had one",
  "death-mobile"
};

char
testEnumStrEqv[][AIR_STRLEN_SMALL] = {
  "bob", "bingo", "bingo bob", 
  "alpha", "alphabet",
  "chip", "crisp", "potato", "potatoe",
  "long long",
  "explorer", "suv",
  ""
};

int
testEnumValEqv[] = {
  testBingo, testBingo, testBingo,
  testAlpha, testAlpha,
  testPotato, testPotato, testPotato, testPotato,
  testNeoClassicalPeriod,
  testSUV, testSUV
};

airEnum
_testEnum = {
  "tests",
  TEST_ENUM_MAX+1,
  testEnumStr,
  NULL,
  testEnumStrEqv,
  testEnumValEqv,
  AIR_FALSE
};

airEnum *
testEnum = &_testEnum;

int
main(int argc, char *argv[]) {
  int i;
  
  /*
  printf("big: %d\n", airStrToEndian("big"));
  printf("big: %s\n", airEndianToStr(4321));
  printf("little: %d\n", airStrToEndian("little"));
  printf("little: %s\n", airEndianToStr(1234));
  printf("me: %s\n", airEndianToStr(airMyEndian));
  printf("\n");
  */

  printf("false: %d -> %s\n", airEnumVal(airBool, "false"),
	 airEnumStr(airBool, AIR_FALSE));
  printf("true: %d -> %s\n", airEnumVal(airBool, "true"),
	 airEnumStr(airBool, AIR_TRUE));
  printf("\n");

  printf("big: %d\n", airEnumVal(airEndian, "big"));
  printf("big: %s\n", airEnumStr(airEndian, 4321));
  printf("little: %d\n", airEnumVal(airEndian, "little"));
  printf("little: %s\n", airEnumStr(airEndian, 1234));
  printf("me: %s\n", airEnumStr(airEndian, airMyEndian));
  printf("\n");

  printf("size = %d\n", (int)sizeof(testEnum));
  printf("name = %s\n", testEnum->name);
  printf("\n");

  printf("|%s|\n", airEnumStr(testEnum, testUnknown));
  printf("|%s|\n", airEnumStr(testEnum, testBingo));
  printf("|%s|\n", airEnumStr(testEnum, testAlpha));
  printf("|%s|\n", airEnumStr(testEnum, testPotato));
  printf("|%s|\n", airEnumStr(testEnum, testNeoClassicalPeriod));
  printf("|%s|\n", airEnumStr(testEnum, testSUV));
  printf("\n");
#define PRINT  printf("%d -> |%s|\n", i, airEnumStr(testEnum, i))
  i = airEnumVal(testEnum, "BoB"); PRINT;
  i = airEnumVal(testEnum, "bing"); PRINT;
  i = airEnumVal(testEnum, "bingo"); PRINT;
  i = airEnumVal(testEnum, "alPHA"); PRINT;
  i = airEnumVal(testEnum, "alphabet"); PRINT;
  i = airEnumVal(testEnum, "chip"); PRINT;
  i = airEnumVal(testEnum, "CHIP"); PRINT;
  i = airEnumVal(testEnum, "potato"); PRINT;
  i = airEnumVal(testEnum, "long long"); PRINT;
  i = airEnumVal(testEnum, "suv"); PRINT;
  i = airEnumVal(testEnum, "explorer"); PRINT;

  return 0;
}
