/*
  teem: Gordon Kindlmann's research software
  Copyright (C) 2002, 2001, 2000, 1999, 1998 University of Utah

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef BANE_PRIVATE_HAS_BEEN_INCLUDED
#define BANE_PRIVATE_HAS_BEEN_INCLUDED

/* range.c */
extern baneRange _baneRangePos;
extern baneRange _baneRangeNeg;
extern baneRange _baneRangeZeroCent;
extern baneRange _baneRangeFloat;

/* inc.c */
extern Nrrd *_baneInc_HistNew(double *incParm);
extern baneInc _baneIncAbsolute;
extern baneInc _baneIncRangeRatio;
extern baneInc _baneIncPercentile;
extern baneInc _baneIncStdv;

/* measr.c */
extern baneMeasr _baneMeasrVal;
extern baneMeasr _baneMeasrGradMag;
extern baneMeasr _baneMeasrLapl;
extern baneMeasr _baneMeasrHess;
extern baneMeasr _baneMeasrCurvedness;
extern baneMeasr _baneMeasrShadeTrace;

/* clip.c */
extern baneClip _baneClipAbsolute;
extern baneClip _baneClipPeakRatio;
extern baneClip _baneClipPercentile;
extern baneClip _baneClipTopN;

/* hvol.c */
extern int _baneValidAxis(baneAxis *ax);

#endif /* BANE_PRIVATE_HAS_BEEN_INCLUDED */

#ifdef __cplusplus
}
#endif
